#!/usr/bin/env python

"""
Program code and data representations.
"""

class Block:

    "A code block."

    def __init__(self):
        self.code = []
        self.location = None

    def __repr__(self):
        return "Block(%r, location=%r)" % (id(self), self.location)

    def as_raw(self, objtable, paramtable):
        for i, item in enumerate(self.code):
            if hasattr(item, "location"):
                item.location = location + i
        return self.code

class DataObject:

    "A representation of a raw program data object."

    def __init__(self, classcode, attrcode, codeaddr, codedetails, name, size, funccode=None):
        self.classcode = classcode
        self.attrcode = attrcode
        self.codeaddr = codeaddr
        self.codedetails = codedetails
        self.name = name
        self.size = size
        self.funccode = funccode

    def with_size(self, size):
        return DataObject(self.classcode, self.attrcode, self.codeaddr, self.codedetails, self.name, size, self.funccode)

    def __repr__(self):
        return "%r # %s" % (
            (self.classcode, self.attrcode, self.codeaddr, self.codedetails, self.funccode, self.size), self.name
            )

# vim: tabstop=4 expandtab shiftwidth=4
